config/routes.rb
Rails.application.routes.draw do
	
  devise_for :users
	
  resources :products
  root to: 'products#index'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/product.rb
class Product < ApplicationRecord
	 mount_uploader :avatar, AvatarUploader
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
  before_action :authenticate_user!
  before_action :configure_permitted_parameters, if: :devise_controller?
	
  protected
	def configure_permitted_parameters
		devise_parameter_sanitizer.permit(:sign_up, keys: [:role])
	end
	
end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
  before_action :set_product, only: [:show, :edit, :update, :destroy]

  # GET /products
  # GET /products.json
  def index
    @products = Product.all
  end

  # GET /products/1
  # GET /products/1.json
  def show
  end

  # GET /products/new
  def new
	if current_user.role == 'Administrador'
    	@product = Product.new
	else
		redirect_to products_url
	end
  end

  # GET /products/1/edit
  def edit
  end

  # POST /products
  # POST /products.json
  def create
    @product = Product.new(product_params)

    respond_to do |format|
      if @product.save
        format.html { redirect_to @product, notice: 'Product was successfully created.' }
        format.json { render :show, status: :created, location: @product }
      else
        format.html { render :new }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /products/1
  # PATCH/PUT /products/1.json
  def update
    respond_to do |format|
      if @product.update(product_params)
        format.html { redirect_to @product, notice: 'Product was successfully updated.' }
        format.json { render :show, status: :ok, location: @product }
      else
        format.html { render :edit }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /products/1
  # DELETE /products/1.json
  def destroy
	if current_user.role == 'Administrador'
    	 @product.destroy
	else
		redirect_to products_url
	end
    respond_to do |format|
      format.html { redirect_to products_url, notice: 'Product was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_product
      @product = Product.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def product_params
      params.require(:product).permit(:title, :year, :description, :artits, :price, :playlist, :avatar)
    end
end

app/controllers/user/confirmations_controller.rb
class User::ConfirmationsController < Devise::ConfirmationsController
  # GET /resource/confirmation/new
  # def new
  #   super
  # end

  # POST /resource/confirmation
  # def create
  #   super
  # end

  # GET /resource/confirmation?confirmation_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after resending confirmation instructions.
  # def after_resending_confirmation_instructions_path_for(resource_name)
  #   super(resource_name)
  # end

  # The path used after confirmation.
  # def after_confirmation_path_for(resource_name, resource)
  #   super(resource_name, resource)
  # end
end

app/controllers/user/omniauth_callbacks_controller.rb
class User::OmniauthCallbacksController < Devise::OmniauthCallbacksController
  # You should configure your model like this:
  # devise :omniauthable, omniauth_providers: [:twitter]

  # You should also create an action method in this controller like this:
  # def twitter
  # end

  # More info at:
  # https://github.com/plataformatec/devise#omniauth

  # GET|POST /resource/auth/twitter
  # def passthru
  #   super
  # end

  # GET|POST /users/auth/twitter/callback
  # def failure
  #   super
  # end

  # protected

  # The path used when OmniAuth fails
  # def after_omniauth_failure_path_for(scope)
  #   super(scope)
  # end
end

app/controllers/user/passwords_controller.rb
class User::PasswordsController < Devise::PasswordsController
  # GET /resource/password/new
  # def new
  #   super
  # end

  # POST /resource/password
  # def create
  #   super
  # end

  # GET /resource/password/edit?reset_password_token=abcdef
  # def edit
  #   super
  # end

  # PUT /resource/password
  # def update
  #   super
  # end

  # protected

  # def after_resetting_password_path_for(resource)
  #   super(resource)
  # end

  # The path used after sending reset password instructions
  # def after_sending_reset_password_instructions_path_for(resource_name)
  #   super(resource_name)
  # end
end

app/controllers/user/registrations_controller.rb
class User::RegistrationsController < Devise::RegistrationsController
  # before_action :configure_sign_up_params, only: [:create]
  # before_action :configure_account_update_params, only: [:update]

  # GET /resource/sign_up
  # def new
  #   super
  # end

  # POST /resource
  # def create
  #   super
  # end

  # GET /resource/edit
  # def edit
  #   super
  # end

  # PUT /resource
  # def update
  #   super
  # end

  # DELETE /resource
  # def destroy
  #   super
  # end

  # GET /resource/cancel
  # Forces the session data which is usually expired after sign
  # in to be expired now. This is useful if the user wants to
  # cancel oauth signing in/up in the middle of the process,
  # removing all OAuth session data.
  # def cancel
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_up_params
  #   devise_parameter_sanitizer.permit(:sign_up, keys: [:attribute])
  # end

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_account_update_params
  #   devise_parameter_sanitizer.permit(:account_update, keys: [:attribute])
  # end

  # The path used after sign up.
  # def after_sign_up_path_for(resource)
  #   super(resource)
  # end

  # The path used after sign up for inactive accounts.
  # def after_inactive_sign_up_path_for(resource)
  #   super(resource)
  # end
end

app/controllers/user/sessions_controller.rb
class User::SessionsController < Devise::SessionsController
  # before_action :configure_sign_in_params, only: [:create]

  # GET /resource/sign_in
  # def new
  #   super
  # end

  # POST /resource/sign_in
  # def create
  #   super
  # end

  # DELETE /resource/sign_out
  # def destroy
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_in_params
  #   devise_parameter_sanitizer.permit(:sign_in, keys: [:attribute])
  # end
end

app/controllers/user/unlocks_controller.rb
class User::UnlocksController < Devise::UnlocksController
  # GET /resource/unlock/new
  # def new
  #   super
  # end

  # POST /resource/unlock
  # def create
  #   super
  # end

  # GET /resource/unlock?unlock_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after sending unlock password instructions
  # def after_sending_unlock_instructions_path_for(resource)
  #   super(resource)
  # end

  # The path used after unlocking the resource
  # def after_unlock_path_for(resource)
  #   super(resource)
  # end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/products_helper.rb
module ProductsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Music</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
	 <div class="topbar">
		 <div class="container" style="padding: 0px 15px;">
			 <% if user_signed_in? %>
  				Bienvenid@ <strong><%= current_user.email %></strong>.
  				<%= link_to 'Editar Perfil', edit_user_registration_path, :class => 'navbar-link' %> 
  				<%= link_to "cerrar sesion", destroy_user_session_path, method: :delete, :class => 'navbar-link'  %>
			 <% else %>
  				<%= link_to "Registrate", new_user_registration_path, :class => 'navbar-link'  %> 
  				<%= link_to "Iniciar Sesion", new_user_session_path, :class => 'navbar-link'  %>
			 <% end %>
		 </div>
	 </div>
	  <div class="header">
		  <div class="container">
		  	<%= image_tag src="logo.png" %>
		  </div>
	  </div>
	  
		  
		  <div class="container prueba">
			  <% if notice %>
  				<p class="alert alert-success"><%= notice %></p>
			  <% end %>
			  <% if alert %>
  				<p class="alert alert-danger"><%= alert %></p>
			  <% end %>
			  
    			<%= yield %>
		  </div>
	  </div>
	  <div class="container footer">
		  <div class="footer-copy">
			  <p>SoundPro &copy; 2017. Todos los derechos reservados</p>
		  </div>
	  </div>
	</body>
</html>

app/views/products/_form.html.erb
<%= form_with(model: product, local: true) do |form| %>
  <% if product.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(product.errors.count, "error") %> prohibited this product from being saved:</h2>

      <ul>
      <% product.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>
  <div class="form-group">
   	<label for="exampleInputFile">Caratula</label>
  	<%= form.file_field :avatar %>
   	<small id="fileHelp" class="form-text text-muted">Selecione una imagen para la presentación para el producto</small>
  </div>
	
  <div class="form-group">
    <label for="exampleInputEmail1">Titulo del Producto</label>
    <%= form.text_field :title, id: :product_title, :class => 'form-control' %>
    <small id="emailHelp" class="form-text text-muted">Ingrese el nombre del producto</small>
  </div> 
	
  <div class="form-group">
    <label for="exampleInputEmail1">Lanzamiento</label>
    <%= form.number_field :year, id: :product_year, :class => 'form-control' %>
    <small id="emailHelp" class="form-text text-muted">Ingrese el año de lanzamiento</small>
  </div>

<div class="form-group">
    <label for="exampleTextarea">Descripción</label>
     <%= form.text_area :description, id: :product_description, :class => 'form-control' %>
  </div>

 <div class="form-group">
    <label for="exampleInputEmail1">Artista</label>
	 <%= form.text_field :artits, id: :product_artits, :class => 'form-control' %>
    <small id="emailHelp" class="form-text text-muted">Ingrese el nombre del artista del producto</small>
  </div>

  <div class="form-group">
    <label for="exampleInputEmail1">Precio</label>
	<%= form.text_field :price, id: :product_price, :class => 'form-control' %>
    <small id="emailHelp" class="form-text text-muted">Ingrese el precio del producto</small>
  </div>

  <div class="form-group">
    <label for="exampleTextarea">Playlist</label>
	 <%= form.text_area :playlist, id: :product_playlist,  :class => 'form-control' %>
  </div>

  <div class="actions">
    <%= form.submit :class => 'btn btn-success' %>
  </div>
<% end %>  

app/views/products/edit.html.erb
<h1>Editing Product</h1>

<%= render 'form', product: @product %>

<%= link_to 'Show', @product %> |
<%= link_to 'Back', products_path %>

app/views/products/index.html.erb
<h1>Nuestros Productos</h1>
    <% @products.each do |product| %>
	  <div class="card meli">
		  <%= image_tag product.avatar, :class => 'card-img-top home' %>
  <div class="card-block">
    <h4 class="card-title"><%= product.title %></h4>
    <p class="card-text"><%= product.description %></p>
	  <%= link_to 'Comprar', product, :class => 'btn btn-primary'%>
	  <% if current_user.role == 'Administrador' %>
	  <div style="float:right">
	   	<%= link_to 'Editar', edit_product_path(product), :class => 'btn btn-outline-success' %>
        <%= link_to 'Eliminar', product, :class => 'btn btn-outline-danger', method: :delete, data: { confirm: 'Are you sure?' } %>
	  </div>
	  <% end %>
  </div>
</div>
    <% end %>

app/views/products/new.html.erb
<h1>Nuevo Producto</h1>

<%= render 'form', product: @product %>

<%= link_to 'Back', products_path %>

app/views/products/show.html.erb
<p id="notice"><%= notice %></p>

<div class="card text-center">
  <div class="card-header">
      <%= @product.title %> ||   <%= @product.year %>
  </div>
  <div class="card-block">
    <h4 class="card-title">  <%= @product.artits %></h4>
	<%= image_tag @product.avatar, :class => 'card-img-top' %>
    <p class="card-text">  <%= @product.playlist %></p>
    <p class="card-text">   <%= @product.description %></p>
    <a href="#" class="btn btn-primary">$ <%= @product.price %></a>
  </div>
  <div class="card-footer text-muted">
    En Existencia
  </div>
</div>

<%= link_to 'Edit', edit_product_path(@product) %> |
<%= link_to 'Back', products_path %>

app/views/users/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Iniciar Sesion", new_session_path(resource_name), :class => 'btn btn-primary btn-sm' %>
<% end -%>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
  <%= link_to "Registrate", new_registration_path(resource_name), :class => 'btn btn-success btn-sm' %>
<% end -%>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
<br>
<br>
  <%= link_to "Olvide mi contraseña", new_password_path(resource_name),:class => 'btn btn-warning btn-sm'  %>
<% end -%>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name) %>
<% end -%>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name) %>
<% end -%>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider) %><br />
  <% end -%>
<% end -%>